#
# Copyright 2020 Oracle Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; If not, see <http://www.gnu.org/licenses/>.

import logging

from .device import VirtualDevice
from .xmlbuilder import XMLBuilder, XMLChildProperty, XMLProperty

class VirtualIommu(VirtualDevice):

    virtual_device_type = VirtualDevice.VIRTUAL_DEV_IOMMU

    _XML_PROP_ORDER = ["model", "aw_bits"]

    model = XMLProperty("./@model", default_cb=lambda s: "intel")
    aw_bits = XMLProperty("./driver/@aw_bits", is_int = True)
    intremap = XMLProperty("./driver/@intremap")
    caching_mode = XMLProperty("./driver/@caching_mode")
    eim = XMLProperty("./driver/@eim")
    iotlb = XMLProperty("./driver/@iotlb")

VirtualIommu.register_type()
